; 
    include \masm32\include\masm32rt.inc
; 

    ; -------------------------------------------------------
    ; This is an assembly-time random number generator based
    ; on code by George Marsaglia:
    ;   #define znew  ((z=36969*(z&65535)+(z>>16))<<16)
    ;   #define wnew  ((w=18000*(w&65535)+(w>>16))&65535)
    ;   #define MWC   (znew+wnew)
    ; -------------------------------------------------------

    @znew_seed@ = 362436069
    @wnew_seed@ = 521288629
    
    @rnd MACRO base:REQ
      LOCAL znew, wnew

      @znew_seed@ = 36969 * (@znew_seed@ AND 65535) + (@znew_seed@ SHR 16)
      znew = @znew_seed@ SHL 16
            
      @wnew_seed@ = 18000 * (@wnew_seed@ AND 65535) + (@wnew_seed@ SHR 16)
      wnew = @wnew_seed@ AND 65535

      EXITM <(znew + wnew) MOD base>
    ENDM

; 
    .data
      counts dd 10 dup(0)
    .code
; 
start:
; 

    ; ------------------------------------------
    ; Test for reasonably uniform distribution.
    ; ------------------------------------------

    xor esi, esi
    xor edi, edi
    REPEAT 1000
      mov eax, @rnd(2)
      .IF eax == 0
        inc esi
      .ELSE
        inc edi
      .ENDIF 
    ENDM
    print ustr$(esi),9
    print ustr$(edi),13,10
    REPEAT 1000
      mov eax, @rnd(10)
      inc DWORD PTR [counts+eax*4]
    ENDM
    N = 0
    REPEAT 10
      print ustr$(counts+N),9
      N = N + 4
    ENDM
    print chr$(13,10,13,10)

    ; ---------------
    ; Eyeball tests.
    ; ---------------

    REPEAT 200
      print ustr$(@rnd(2))
    ENDM
    print chr$(13,10,13,10)

    REPEAT 200
      print ustr$(@rnd(10))
    ENDM
    print chr$(13,10,13,10)

    REPEAT 100
      print ustr$(@rnd(1000)),13,10
    ENDM

    REPEAT 100
      print ustr$(@rnd(0ffffffffh)),13,10
    ENDM

    inkey "Press any key to exit..."
    exit
; 
end start
 